/*
 * propeller_clock.c
 *
 */

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 15155000
		
#include <util/delay.h>

#define MIN_START 15;
#define HOUR_START 30;

int seconds = 0;
int minutes = MIN_START;
int hours = HOUR_START;

ISR(TIMER1_COMPA_vect) {
	seconds++;
	if(seconds == 10 || seconds == 40) {
		hours++;
		minutes++;
	}

	if(seconds == 60) {
		seconds = 0;
		minutes++;

		if((minutes % 10) == 0) {
			hours++;
		}

		if(minutes == 60) {
			minutes = 0;

			if(hours == 60) {
				hours = 0;
			}
		}
	}
}

void timer1_init() {
    TCCR1B |= (1 << CS12)| (1 << CS10) | (1 << WGM12);

    TIMSK1 |= ( 1<< OCIE1A);
    OCR1A = 15625;
}

void loop() {
	/* Setare directii porturi folosite */
	int i;
	int ok;

	DDRD |= (1 << PD0);
	DDRD |= (1 << PD1);
	DDRD |= (1 << PD2);

	DDRD  &= ~(1 << PD6);
	PORTD |=  (1 << PD6);

	PORTD |= (1 << PD0);
	PORTD |= (1 << PD2);
	
	while(1) {
		for(i = 0; i < 60; i++) {
			ok = 0;

			if(i == seconds) {
				PORTD &= ~(1 << PD1);
				ok = 1;
			} else {
				PORTD |= (1 << PD1);
			}

			if(i == minutes) {
				ok = 1;
				PORTD &= ~(1 << PD2);
			} else {
				PORTD |= (1 << PD2);
			}

			if(i == hours) {
				ok = 1;
				PORTD &= ~(1 << PD0);
			} else {
				PORTD |= (1 << PD0);
			}

			if(!ok) {
				PORTD &= ~(1 << PD0);
				PORTD &= ~(1 << PD1);
				PORTD &= ~(1 << PD2);
			}

			_delay_ms(0.2);
		}
	}
}


int main(void) {
	srand((unsigned int)NULL);
	timer1_init();
	sei();
	loop();
	
	return 0;
}

